# syntax=docker/dockerfile:1.4

# BUILD STAGE
FROM node:lts-iron AS builder

# Establecer el directorio de trabajo
WORKDIR /www

# Copiar los archivos de dependencias
COPY package.json .
COPY tsconfig*.json .
RUN yarn install

RUN mkdir -p ./shared
RUN mkdir -p ./client

COPY shared ./shared
COPY client ./client

#CMD pwd && ls -la

RUN cd ./shared && yarn install
RUN cd ./client && yarn install

# Ejecutar el build
# Si hay un error, mostrarlo en detalle.
RUN cd ./client && yarn run build || { echo 'Error during build'; exit 1; }

# FINAL STAGE (Producción)
FROM node:lts-iron AS prod

WORKDIR /www

# Copiar los archivos del build desde la fase anterior
COPY --from=builder /www/client/dist .
# COPY --from=builder /www/client/package.json .
#COPY --from=builder /api/server/tsconfig.production.json ./tsconfig.json

# Instalar sólo las dependencias de producción en el servidor
# CMD yarn install --production

# Exponer el puerto que la API usa
#EXPOSE 80

#CMD pwd && ls -la
#CMD cat package.json

# Comando para correr la aplicación
#CMD node -r ts-node/register/transpile-only -r tsconfig-paths/register ./server/src/index.js